# Contributing

We'd love for you to contribute and to make this project even better than it is today! If this interests you, please make sure to follow the steps below before creating a Pull Request.

When we mention `VSCode`, we mean the `Visual Studio Code` editor which can be downloaded [here](https://code.visualstudio.com)

Before accepting any Pull Request, we would you like to remind you to follow these steps:
1. Install dependencies
```sh
npm install
```
2. Run a full build
```sh
npm run build:prod
```
3. Fix any Linting or TypeScript issues (if any) returned by the build process
4. After being done with step 2 and 3, then the final step would be to proceed with your Pull Request
   - **NOTE** even though the `dist/` folder is included in Git for portability, you could choose (we stringly recommend) that you ignore/disregard these files from being included in your Pull Request.
